<template>
    <div id="container">
            <div id="block_haut">
                    <div id="imgPseudo" > 
                        <b-avatar :src="require('@/assets/img/' + avatar)" size="6rem" id="avatarUserConnected"></b-avatar>
                    </div>
                    <div >
                        <table id="modifyInfo">
                            <tr>
                                <td>
                                    <p id="login" v-on:click="editBox('#login')"></p>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <p id="email" v-on:click="editBox('#email')"></p>   
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <p id="intro" v-on:click="editBox('#intro')"></p>        
                                </td>
                            </tr>
                        </table>
                    </div>
            </div> 
            <div id="lpanel">
                <div id="follower">
                    <h1 id="followerTitle"> Here are all your followers! </h1>
                    <b-table striped hover :items="eachUser" thead-class="d-none">
                        <template #cell(avatar)="data">
                            <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe">
                        </template>
                    </b-table> 
                </div>
            </div>    
        <div id="cpanel">
            <b-table striped hover :items="ownPublication" :fields="fieldsPublication" thead-class="d-none">
                 <template #cell(avatar)="data">
                    <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe">
                   
                </template>
                <template #cell(publication)="pub">
                    <span v-html="pub.item.publication"></span>
                    <b-icon icon="trash-fill" @click="deletedPost(pub.item.id_publication)"></b-icon>
                </template>
            </b-table>
        </div>

        <div id="rpanel">
           <h2 id="whoToFollowTitle">Maybe you know them?</h2>
           <b-table striped hover :items="toFollow" thead-class="d-none">
                     <template #cell(avatar)="data">
                        <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe">
                    </template>
                    <template v-slot:cell(button)="data">
                        <b-button id="subscribeButton" @click="subscribe(data.item.login_user)">Subscribe</b-button>
                    </template>
            </b-table>
        </div>

    </div>
</template>

<script>
import { getUserById } from '../api_wrapper/api_calls.js';
import { getEveryonePublication } from '../api_wrapper/api_publication.js';
import { getUserAndEveryonePublication } from '../api_wrapper/api_user_allpublication.js';
import { getEachUser } from '../api_wrapper/api_user_list.js';
import { getUserAndHisFollower } from '../api_wrapper/api_user_follower.js';
import { deletedPosts } from '../api_wrapper/api_deletedPost.js';
import Cookies from 'js-cookie';
import { eventBus } from './event.js';
import { getFollower } from '../api_wrapper/api_follower.js';
import { getTOFollower } from '../api_wrapper/api_NOTFollower.js';
import { getOwnPubli } from '../api_wrapper/api_ownPubli';
import { subscribeTo } from '../api_wrapper/api_subscribe'
import $ from 'jquery';

    export default 
    {
        name: 'profilepage',
 
        data(){
            return {
                clickable:'',
                iduser:'',
                email:'',
                ownPublication:[], //user own publication
                login:'',
                intro : '',
                password:'',
                avatar: '',
                everyPublication:[],  
                profilePublication:[], 
                searchPublication: [], 
                activePublication: [],
                toFollow:[], 
                eachUser:[],
                isSearch: false,
                isError:false, //show error condition with v-if
                isLogin:false,
                tag: '',
                authenInfo:'', 
                noTouchEver:[], //save pub, don't change ever, do forEach here
                fieldsPublication: [{key:'avatar', sortable: false},
                         {key:'create_date', sortable: false}, 
                         {key:'login_user', sortable: false}, 
                         {key:'publication', sortable: false}] 
            }
        }, 

        created() {

            //on : check the message, activate the change
            eventBus.$on('refreshPage', (authen) => {
                this.authenInfo = authen;
                this.login = this.authenInfo.login_user;
                this.isLogin = true;
                this.userAndAllPublication();
                this.userAndfollower();
                Cookies.remove("login");
                Cookies.remove("email");
                Cookies.remove("intro");
      
            });

            eventBus.$on('logOut', ()=>{
                //click on déconnecter, return main page
                this.isLogin = false;
                this.allPublication(); 
                this.allUser();
                Cookies.remove("login");
                Cookies.remove("email");
                Cookies.remove("intro");
            });
        },

        //mounted
        async mounted() { 

            const userId = Cookies.get('user_id'); //return value
            const user = await getUserById(userId);

            //if no user login, main page shows the posts which contain @everyone and all the users
            if (user == null){
                this.allPublication(); 
                this.allUser();
            }else{
            //else main page change dynamically with the post of user's follower, all the post with @everyone and the post which had tag user
                await this.userAndAllPublication();
                await this.userAndfollower();
                
                this.login = user.login_user;
                this.email = user.email;
                this.intro = user.introduction;
                this.avatar = user.avatar;
                this.iduser = user.id_user;

                this.eachUser = await getFollower(user.id_user);
                
                this.toFollow = await getTOFollower(user.id_user);
                this.toFollow.forEach(element => {
                    element["button"] = element["login_user"];
                });

                this.ownPublication = await getOwnPubli(user.id_user);

                $("#login").html(this.login);
                $("#email").html(this.email);
                $("#intro").html(this.intro);
            }
        },

        methods:{
            
            //delete the post of user connected
            async deletedPost(id_publication){
                
                await deletedPosts(id_publication, this.iduser);
                this.ownPublication = await getOwnPubli(this.iduser);
            },
        
            async subscribe(login_user){
                await subscribeTo(login_user,this.login);
                this.toFollow = await getTOFollower(this.iduser);
                this.toFollow.forEach(element => {
                    element["button"] = this.iduser;
                });
                this.eachUser = await getFollower(this.iduser);
            },

            editBox(balise){
                if(this.clickable != '' && balise != this.clickable){
                    return;
                }

                var id = event.target.id;
                var content = $("#writeChange").val() != undefined ? $("#writeChange").val() : $(balise).text();

                if(id == "validChange"){//ici quand on click sur ok
                    $(balise).empty();
                    $(balise).html(content);
                    this.clickable = '';
                    Cookies.set(balise.substring(1),content);

                }else{//ici quand on clique sur le champ
                    if(id != "writeChange"){
                        var toAdd = `<input type="text" id="writeChange" height="100vh" size="80%" value="`.concat(content).concat(`">`);
                        toAdd += `<input type="submit" id="validChange" value="Ok" v-on:click="console.log('yes')">`
                        $(balise).html(toAdd);
                        this.clickable = balise;
                    }
                }
            },

            //the posts which contain @everyone
            async allPublication(){
                this.everyPublication = await getEveryonePublication();
                this.activePublication = this.everyPublication;
                this.noTouchEver = this.everyPublication;
            },

            //the posts of user connected nad the posts which contain @everyone
            async userAndAllPublication(){
                this.profilePublication = await getUserAndEveryonePublication(this.login);
                this.activePublication = this.profilePublication; //activePub is where the pubs chagne, we use it in b-table also
                this.noTouchEver = this.profilePublication;
            }, 

            //all the user on the main page
            async allUser(){
                this.eachUser = await getEachUser();
            }, 
            
            //the follower of user connected
            async userAndfollower(){
                this.eachUser = await getUserAndHisFollower(this.login);
            },
        }
    }
</script>

<style scoped>

    
    body{
        text-align: center;
    }

    #imgPseudo{
        margin: auto;
    }

    #avatarUserConnected{
        margin-left :1vh;
    }

    #modifyInfo{
        text-align: left;
        vertical-align: middle!important;
    }

    #writeChange, #validChange {
        background-color: black;
    }

    #block_haut{
        background-color:whitesmoke;
        margin-left:2vh;
        border-radius: 1rem;
        display: flex;
        position: fixed;
        width: 50vh;
        height: 24vh;
        overflow: auto;
    }

    #login{
        width: 100%;
        text-align: left;
        margin-top: 2vh;
        margin-left:1vh;
        margin-bottom: 0vh;
    }

    #intro{
        width:100%;
        text-align: left;
        margin-left:1vh;
    }

    #email{
        width: 100%;
        text-align: left;
        margin-top:2vh;
        margin-left:1vh;
    }

    #subscribeButton{
        margin:0 0 2vh 3vh; /* top right bottom left*/
        border-radius: 0.50rem;
        text-align: center;
        background-color:#91989F;
        border-color:transparent;
        width: 90pt;
        height: 4vh;
        margin-right: 7px;
    }

    #container{
        position: fixed;
        left: 2%;
        right : 2%;
        width: 96%;
        margin: auto;
        display: flex;
        border-radius: 1rem;
        background-color: transparent;
        overflow-x: hidden;
    }

    #lpanel{ /* followers */
        position:relative;
        left: 0;
        width: 60vh;
        margin-left: 2vh;
        margin-top:26vh;
        top: 0;
        border-radius: 1rem;
        background-color: whitesmoke;
    }

     #rpanel{ /* who to follow */
        position:relative;
        left: 0;
        width: 25%;
        margin-left: 2vh;
        top: 0;
        border-radius: 1rem;
        background-color: whitesmoke;
    }

    #cpanel{ /* publication */
        position:relative;
        left: 0;
        width: 50%;
        margin-left: 2vh;
        top: 0;
        border-radius: 1rem;
        background-color: whitesmoke;
        overflow: auto;
    }


    #follower{
        position: relative;
        z-index: 1;
        overflow:auto;
    }

    #followerTitle, #whoToFollowTitle{
        text-align: center;
        font-size: large;
        margin-top:1vh;
    }

    #modifyInfo{
        border-radius: 0.50rem;

    }

</style>